﻿@{
    ViewBag.Title = "Review Ryoko Expenses";
}
@using Microsoft.AspNet.Identity
<style>
    #chartContainer
    {
        overflow-x: auto;
        background-color: #F0F0F0;
        padding: 5px;
    }
    svg
    {
        height: 550px;
        width: 100%;
    }
    .y.axis line
    {
        stroke: #666;
        stroke-width: 1.5px;
        opacity: 0.35;
    }
</style>

<main>
    <section>
        <h3>Your Expense History:</h3>
        <div id="chartKey">
            <span id="color1">&nbsp;&nbsp;&nbsp;&nbsp;</span>Car Expense<br/>
            <span id="color2">&nbsp;&nbsp;&nbsp;&nbsp;</span>Plane Expense<br />
            <span id="color3">&nbsp;&nbsp;&nbsp;&nbsp;</span>Train Expense<br />
        </div>

        <label><input type="radio" name="mode" value="bar" checked> Bar Chart</label>
        <label><input type="radio" name="mode" value="pie"> Pie Chart</label>

        <div id="chartContainer">

        </div>
    </section>
</main>


<script>
    // On resize, redraw current graph the user has selected.
    $(window).resize(function () {
        $('#chartContainer').empty();
        if ($("input[type=radio]:checked").val() == "pie")
            drawPieChart();
        else
            drawBarChart();
    });

    var jsonData = [];
    var pieData = [];
    var tickValues = [];

    var stripTime = function (date) {
        var newDate = date;
        newDate.setHours(date.getHours() + 5);
        newDate.setHours(0);
        newDate.setMinutes(0);
        newDate.setSeconds(0);
        newDate.setMilliseconds(0);
        return newDate;
    };

    // Function to handle no duplicates in the tickValues list.
    var checkToPushValue = function(date)
    {
        var found = false;
        for(var i = 0; i < tickValues.length; i++)
        {
            if(tickValues[i] == date)
            {
                found = true;
                break;
            }
        }
        if(!found)
        {
            tickValues.push(date);
        }
    }

    $(window).ready(function () {
        // Change the graph displayed based off of radio selection.
        $("input[type=radio]").change(function () {
            if (this.value == "bar") {
                $('#chartContainer').empty();
                drawBarChart();
            }
            else if (this.value == "pie") {
                $('#chartContainer').empty();
                drawPieChart();
            }
        });

        // Get all of the dat for the current user, and correctly parse date objects for D3.js
        $.ajax("user/@User.Identity.GetUserId()")
        .done(function (data) {
            var dateTimeReviver = function (key, value) {
                var a;
                if (typeof value === 'string') {
                    a = /\/Date\((\d*)\)\//.exec(value);
                    if (a) {
                        var result = stripTime(new Date(+a[1]));
                        checkToPushValue(result);
                        return result;
                    }
                }
                return value;
            }
            jsonData = JSON.parse(data, dateTimeReviver);
            tickValues.sort(function (a, b) {
                if(new Date(a) < new Date(b))
                {
                    return -1;
                }
                else if (new Date(a) > new Date(b)) {
                    return 1;
                }
                else
                {
                    return 0;
                }
            })
            drawBarChart();
        });
    });

    function drawBarChart() {
        // sample chart taken from http://bl.ocks.org/mbostock/3943967
        
        var jsonTestData =
            [
                [
                    { "id": 1, "Date": 'July 1, 2016', "type": "plane", "Cost": 1 },
                    { "id": 2, "Date": 'July 2, 2016', "type": "plane", "Cost": 2 },
                    { "id": 3, "Date": 'July 3, 2016', "type": "plane", "Cost": 3 },
                ],
                [
                    { "id": 4, "Date": 'July 1, 2016', "type": "car", "Cost": 1 },
                    { "id": 5, "Date": 'July 2, 2016', "type": "car", "Cost": 2 },
                    { "id": 6, "Date": 'July 3, 2016', "type": "car", "Cost": 3 },
                ],
                [
                    { "id": 7, "Date": 'July 1, 2016', "type": "train", "Cost": 1 },
                    { "id": 8, "Date": 'July 2, 2016', "type": "train", "Cost": 2 },
                    { "id": 9, "Date": 'July 3, 2016', "type": "train", "Cost": 3 }
                ]
            ];

        
        var n = 3, // Assuming maximum number of layers (data types) of three.
            stack = d3.layout.stack(),
            layers = jsonData,
            yGroupMax = d3.max(layers,
            function (layer) {
                return d3.max(layer,
                    function (d) {
                        return d.Cost;
                    });
            });

        var width = $('section').width() - 15,
            gridWidth = Math.max(tickValues.length * 30 + 00, $('#chartContainer').width() - 25),
            eleWidth = 15,
            xRangeWidth = eleWidth * tickValues.length,
            height = 500;

        var min = d3.min(layers, function (layer) { return d3.min(layer, function (d) { return d.Date; }); });
        var max = d3.max(layers, function (layer) { return d3.max(layer, function (d) { return d.Date; }); });

        var x = d3.scale.ordinal()
            .domain(tickValues)
            .rangePoints([0, tickValues.length * 50]);
        
        var y = d3.scale.linear()
            .domain([0, yGroupMax])
            .range([height, 10]);

        var color = d3.scale.linear()
            .domain([0, n - 1])
            .range(["#49111C", "#FF3D60"]);

        var usedTicks = [];

        var xAxis = d3.svg.axis()
            .scale(x)
            .tickValues(tickValues)
            .tickFormat(function (d, i) {
                var label = (d.getMonth()+1) + "-" + d.getDate() + "-" + d.getFullYear();
                return label;
            })
            .tickSize(0)
            .tickPadding(4)
            .orient("bottom");

        var yAxis = d3.svg.axis()
            .scale(y)
            .tickFormat(function (d, i) {
                return d;
            })
            .tickSize(0)
            .tickPadding(4)
            .orient("left");

        var svg = d3.select("#chartContainer").append("svg")
            .attr("style", "width: " + (gridWidth + 00) + "px")
            .append("g")
            .attr("transform", "translate(50,0)")
            .attr("width", gridWidth+"px");

        var layer = svg.selectAll(".layer")
            .data(layers)
            .enter().append("g")
            .attr("class", "layer");

        var rect = layer.selectAll("rect")
            .data(
            function (d)
            {
                return d;
            })
            .enter().append("rect")
            .attr("x",
            function (d)
            {
                return x(d.Date);
            })
            .attr("y", height)
            .attr("width", 30)
            .attr("height", function (d)
            {
                return 0;
            })
            .style("fill",
                function (d, i) {
                    if(d.Type == "car")
                        return color(0);
                    else if (d.Type == "plane")
                        return color(1);
                    else i
                        return color(2);
                });

        rect.transition()
            .delay(
            function (d, i) {
                return i * 10;
            })
            .attr("y",
            function (d) {
                return height;
            })
            .attr("height",
            function (d) {
                return 0;
            });

        svg.append("g")
            .attr("class", "x axis")
            .attr("transform", "translate(20," + height + ")")
            .call(xAxis)
            .selectAll("text")
                .attr("transform", "translate(40, 120) rotate(30)");

        svg.append("g")
            .attr("class", "y axis")
            .attr("transform", "translate(-100,0)")
            .call(yAxis)
            .selectAll("text");
        
        var gridLines = svg.selectAll("line")
            .attr("x2",
            function (d) {
                return gridWidth + 00;
            })
            .attr("transform", "translate(3000,0)");

        // Begin transition animation.
        y.domain([0, yGroupMax]);

        rect.transition()
            .duration(500)
            .delay(function (d, i) { return i * 10; })
            .attr("x",
            function (d, i, j) {
                return x(d.Date) + 30 / n * j;
            })
            .attr("width", 30 / n)
            .transition()
            .attr("y",
            function (d) {
                return y(d.Cost);
            })
            .attr("height",
            function (d) {
                return height - y(d.Cost);
            });

        gridLines.transition()
            .duration(1000)
            .delay(function (d, i) { return i * 10; })
            .attr("transform", "translate(0,0)");

        svg.selectAll(".y.axis").transition()
            .duration(1500)
            .delay(function (d, i) { return i * 10; })
            .attr("transform", "translate(-20,0)");

        svg.selectAll(".x.axis").transition()
            .duration(1500)
            .delay(function (d, i) { return i * 10; })
            .attr("transform", "translate(0,400)");
    }

    function drawPieChart() {
        var width = $('section').width() - 40;
        var height = Math.min(500, width);
        var radius = height / 2;
        var n = 3;
        var τ = 2 * Math.PI;
        var color = d3.scale.linear()
            .domain([0, n - 1])
            .range(["#49111C", "#FF3D60"]);

        // Draw the pie chart off the screen to allow cleaner animation.
        var svg = d3.select('#chartContainer')
          .append('svg')
          .attr('width', width)
          .attr('height', height)
          .append('g')
          .attr('transform', 'translate(' + (width / 2) + ',' + (height / 2) + ')');

        var arc = d3.svg.arc()
            .startAngle(function (d)
            {
                return d.startAngle;
            })
            .endAngle(function (d)
            {
                return d.endAngle;
            })
            .outerRadius(radius);

        var pie = d3.layout.pie()
          .value(function (d)
          {
              var total = 0;
              $.each(d, function (index, value) {
                  total += value.Cost;
              })
              return total;
          })
          .sort(null);

        var path = svg.selectAll('path')
            .data(pie(jsonData))
            .enter()
            .append('path')
            .attr('d', arc)
            .attr('fill', function (d, i) {
                return color(i);
            })
            .attr("transform", "translate(-" + (width+radius) + ", 0)");

        // Begin animation logic.
        svg.selectAll("path").transition()
            .delay(function (d, i) { return i * 75; })
            .duration(2500)
            .attr("transform", "translate(0, 0) rotate(180)");
    }
</script>